import { message } from 'antd'
import axios from 'axios'
//获取当前时间
export function getmyDate(form) {
    var date = new Date();
    var year = date.getFullYear().toString();
    var month = (date.getMonth()+1< 10 ? '0'+(date.getMonth()+1): date.getMonth()+1).toString();
    var day = (date.getDate()< 10 ? '0' +(date.getDate()): date.getDate()).toString();
    var hour = (date.getHours()< 10 ? '0' + date.getHours(): date.getHours()).toString();
    var minute = (date.getMinutes()<10 ? '0' + (date.getMinutes()): date.getMinutes()).toString();
    var second = (date.getSeconds()<10 ? '0' + date.getSeconds(): date.getSeconds()).toString();
    if(!form){
        return year+month+day+hour+minute+second;
    }else if(form=="YY-MM-DD hh:mm:ss"){
        return year+'-'+month+'-'+day+' '+hour+':'+minute+':'+second;
    }
};
//时间戳转化
export function format(fmt) {
    var date = new Date(fmt);
    var year = date.getFullYear().toString();
    var month = (date.getMonth()+1< 10 ? '0'+(date.getMonth()+1): date.getMonth()+1).toString();
    var day = (date.getDate()< 10 ? '0' +(date.getDate()): date.getDate()).toString();
    var hour = (date.getHours()< 10 ? '0' + date.getHours(): date.getHours()).toString();
    var minute = (date.getMinutes()<10 ? '0' + date.getMinutes(): date.getMinutes()).toString();
    var second = (date.getSeconds()<10 ? '0' + date.getSeconds(): date.getSeconds()).toString();
    return year+'-'+month+'-'+day+' '+hour+':'+minute+':'+second;
}

Date.prototype.formats = function (fmt) {
    let o = {
      "M+": this.getMonth() + 1,                 //月份
      "d+": this.getDate(),                    //日
      "h+": this.getHours(),                   //小时
      "m+": this.getMinutes(),                 //分
      "s+": this.getSeconds(),                 //秒
      "q+": Math.floor((this.getMonth() + 3) / 3), //季度
      "S": this.getMilliseconds()             //毫秒
    };
    if (/(y+)/.test(fmt)) {
      fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
    for (let k in o) {
      if (new RegExp("(" + k + ")").test(fmt)) {
        fmt = fmt.replace(RegExp.$1, (RegExp.$1.length === 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
      }
    }
    return fmt;
  };

//请求API,json形式
export function $Axios (method,urls, param, fn, err) {
    let url;
    if(process.env.NODE_ENV === 'development'){ 
        url = 'http://paytest.zhongsou.com'//开发测试环境API
    }else{  
        url = 'http://pay.zhongsou.com' //生产线上环境API
    }
	let methods = method.trim()
	let obj = {
		method: methods, //请求方式
        changeOrigin: true,
		headers: { 'content-type': 'application/json;charset=utf-8' },
		url: url + urls,
        timeout: 30000, // 请求时间 超过这个时间 将停止请求
        // params: {
        //     action:"queryList",//查询商户入网列表
        //     merchantStatus:1, //当前固定为1  //商户状态0待激活1活动中2关闭3删除4已冻结5清退6退驻
        //     pSize:10,//每页条数
        //     lastId:1111 //最后一个排序号,即最后一条记录的id值
        // }
    }

    if(method=='post'){
        obj.data = param
    }

    if(method=='get'){
        obj.params= param
    }

    
	axios(obj)
		.then((response) => {
			fn(response)
		})
		.catch((e) => {
			if (err) err()
			console.log(e)
		})
}

//请求API,json形式
export function $AxiosGet (method,urls, param, fn, err) {
    let url;
    if(process.env.NODE_ENV === 'development'){ 
        url = 'http://api2test.zhongsou.com/'//开发测试环境API
    }else{  
        url = 'http://api2.souyue.mobi/d3api2' //生产线上环境API
    }
	let methods = method.trim()
	let obj = {
		method: methods, //请求方式
        changeOrigin: true,
		headers: { 'content-type': 'application/json;charset=utf-8' },
		url: url + urls,
        timeout: 30000, // 请求时间 超过这个时间 将停止请求
    }

    if(method=='post'){
        obj.data = param
    }

    if(method=='get'){
        obj.params= param
    }

    
	axios(obj)
		.then((response) => {
			fn(response)
		})
		.catch((e) => {
			if (err) err()
			console.log(e)
		})
}

//请求API,form形式
export function $Axios_form (method, url, param, fn, err) {
    //let methods = method.trim()

    let obj = {
		method: method,
		headers: { 'content-type': 'application/x-www-form-urlencoded;charset=utf-8' },
		url: url,
		//timeout: 30000
    }

    if(method = 'get'){
        let param_get = {}
        param_get.json = JSON.stringify(param).trim()
        obj.params = param_get
    }else if(method = 'post'){
        url = url + '?json={';
        Object.entries(param).map((item,index)=>{
            Object.entries(param).length-1 == index ?  (url += `"${item[0]}":"${item[1]}"`) : url += `"${item[0]}":"${item[1]}",`
        })
        url = url + '}'
    }
    
	axios(obj)
		.then((response) => {
			fn(response)
		})
		.catch((e) => {
			if (err) err()
			console.log(e)
		})
}