import React from 'react';
import { Input, Button ,message ,Spin   } from 'antd';
import { LoadingOutlined } from '@ant-design/icons';
import { $Axios } from '../../common/publish';
const antIcon = <LoadingOutlined style={{ fontSize: 24 }} spin />;
export default class AccountOverview extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            headTxt : '财务管理 > 发起提现',
            data : '',
            isPwd : '',
            psd : '',
            je : '',
            lodings : false
        }
        
    }
	
	componentDidMount() {
        this.initData()
    }

    initData(){
        let that_ = this;
        that_.setState({
            lodings : false
        })
        let url = '/payment/merchant.pickup.groovy'
        let params = {
            action :"queryOpInfo", //提现操作相关信息，可提现金额等
            appName :JSON.parse(localStorage.getItem('userData')).appName, //当前商户的appname，
            merchantId : JSON.parse(localStorage.getItem('userData')).merchantId//商户ID在第三方的唯一编号，
        }
        $Axios('get',url,params,(res) => {
            let status = res.data.head.status;
            if(status == 200){
                let data = res.data.body;
                that_.setState({
                    data : data,
                    isPwd  : data.isPwd,
                    lodings : true
                })
            }
        })
    }
    
    subClick(){
        if( document.getElementById("je").value !== ''){
            if( document.getElementById("pwd").value !== ''){
                if(this.state.data.withdrawBalance > 0 && this.state.data.withdrawBalance < document.getElementById("je").value){
                    if(this.state.isPwd == 1){
                        let that_ = this;
                        let url = '/payment/merchant.pickup.groovy'
                        let params = {
                            action :"create",//提现
                            appName : JSON.parse(localStorage.getItem('userData')).appName,//当前商户的appname，
                            merchantId : JSON.parse(localStorage.getItem('userData')).appmerchantIdName,//商户ID在第三方的唯一编号，
                            withdrawAmount : document.getElementById("je").value,//提现金额以元为单位，默认都是人民币，以元为单位
                            pwd : document.getElementById("pwd").value//String,交易密码
                        }
                        $Axios('get',url,params,(res) => {
                            let status = res.data.head.status;
                            if(status == 200){
                                message.info('提交成功,请注意账户变更!');
                            }else{
                                message.info('提交失败,原因未知!');
                            }
                        })
                    }else{
                        message.info('请先设置支付密码,再进行提现!');
                    }
                }else{
                    message.info('可提现额度不足!');
                }
            }else{
                message.info('请输入交易密码 !');
            }
        }else{
            message.info('请输入提现金额 !');
        }
       
    }

    btnCzClick(){
        this.initData(); //重置后重新刷新可提现金额
        let zTimeBegin = new Date();                                                                                       
        let keys = zTimeBegin.getTime()  // 时间转成时间戳
        console.log(keys)
        this.setState({
            je : keys,
            pwd : keys
        })
    }


    render() {
        const { headTxt ,data ,pwd ,je ,lodings } = this.state;
        return(
            <div className='wrap_table'>
                <div className='header_center'>
                   { headTxt }
               </div>
               <div className='query_table'
                style={{
                    padding:'30px',
                    height : '500px',
                    overflow:'hidden'
                }}
               >
                   <div className='top_div' style={{height : '100%'}}>
                        <div>
                            <div style={{width:'120px',display : 'inline-block',}}> 可提现金额 ： </div>
                            {
                                lodings == false && <Spin indicator={antIcon} />
                            }
                            {
                                lodings == true && <text>{data.withdrawBalance == '' ? '--' : data.withdrawBalance}</text>
                            }
                       </div>
                       <div>
                            <div style={{width:'120px',display : 'inline-block',}}> 提现金额 ： </div>
                            <div style={{width:'200px',display:'inline-block'}}><Input id='je' key={je}  placeholder="请输入金额" /></div>
                       </div>
                       <div>
                            <div style={{width:'120px',display : 'inline-block',}}> 手续费 ： </div>
                            0元
                       </div>
                       <div>
                            <div style={{width:'120px',display : 'inline-block',}}> 交易密码 ： </div>
                            <div style={{width:'200px',display:'inline-block'}}><Input id='pwd' key={pwd} placeholder="请输入密码" /></div>
                       </div>
                       <div>
                            <Button onClick={this.btnCzClick.bind(this)}>重置</Button>
                            <Button type="primary" style={{marginLeft:'20px'}} onClick={this.subClick.bind(this)}>提交</Button>
                       </div>
                   </div>
               </div>
            </div>
        )
    }
}