import React from 'react';
import { Button, Table, Select, Input, DatePicker, Space, message, Modal, Steps, Spin } from 'antd';
import 'moment/locale/zh-cn';
import locale from 'antd/es/date-picker/locale/zh_CN';
import { $Axios, format } from '../../common/publish';
import '../Refund-inquiry/Refund-inquiry.scss'
const { Column, ColumnGroup } = Table;
const { Step } = Steps;
const that_ = this;
export default class RefundInquiry extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            headTxt: '财务管理 > 退款查询',
            data: [],
            columns: [
                {
                    title: '序号',
                    dataIndex: 'num',
                    key: 'num',
                },
                {
                    title: '订单号',
                    dataIndex: 'orderNo',
                    key: 'orderNo',
                },
                {
                    title: '订单金额',
                    dataIndex: 'totalAmount',
                    key: 'totalAmount',
                },
                {
                    title: '支付金额',
                    dataIndex: 'cash',
                    key: 'cash',
                },
                {
                    title: '本金金额',
                    dataIndex: 'stbPrice',
                    key: 'stbPrice',
                },
                {
                    title: '积分币金额',
                    dataIndex: 'benbiPrice',
                    key: 'benbiPrice',
                },
                {
                    title: '退款金额',
                    dataIndex: 'refundAmount',
                    key: 'refundAmount',
                },
                {
                    title: '退款请求时间',
                    dataIndex: 'createTime',
                    key: 'createTime',
                },
                {
                    title: '退款完成时间',
                    dataIndex: 'finishTime',
                    key: 'finishTime',
                },
                {
                    title: '支付方式',
                    dataIndex: 'payType',
                    key: 'payType',
                },
                {
                    title: '退款状态',
                    dataIndex: 'orderStatus',
                    key: 'orderStatus',
                },
                {
                    title: '操作',
                    dataIndex: 'cz',
                    key: 'cz',
                    render: (text, record, index) => <a onClick={() => this.xqClick(text, record, index)}>查看详情</a>,
                },
            ],
            params: {
                action: "refundList",   //查询订单退款记录
                appName: JSON.parse(localStorage.getItem('userData')).appName,//当前商户的appName
                pSize: 10, //每页条数
                pNo: 1,//第几页，起始值从1开始
                orderStatus: '', //退款状态：1 处理中PROCESS, 2 成功SUCCESS, 3 失败FAIL 
                orderNo: '',//商城订单号
                requestId: '',//退款请求号
                userName: '', //发起人
                payType: '',//支付方式： 1支付宝 2微信 5 微包
                timeType: '',//为0或不提供此字段，表示不限制， 1 创建时间，2完成时间
                begTime: '', //开始时间时间戳
                endTime: '', // 结束时间时间戳
            },
            total: null,
            current: 1,
            paginationProps: {
                showSizeChanger: false,//设置每页显示数据条数
                showQuickJumper: false,
                showTotal: () => `共${this.state.total}条`,
                pageSize: 10,
                total: null,  //数据的总的条数
                onChange: (current) => this.changePage(current), //点击当前页码
            },
            lodings: null,
            types: null,
            timeType: null,
            starTime: '',
            endTime: '',
            keys: 1,
            isModalVisible: false,
            refundInfo: '',
            userInfo: '',
            tklodangs: false
        }

    }

    componentDidMount() {
        this.initData()
    }


    initData() {
        this.setState({
            lodings: true
        })
        let that_ = this;
        let orderNo = document.getElementById("orderNo").value //商城订单号
        let userName = document.getElementById("userName").value //发起人
        let url = '/payment/merchant.order.query.groovy'
        let params = this.state.params;
        if (this.state.types == 1) {
            this.state.params.orderNo = orderNo;
            this.state.params.requestId = '';
        } else {
            this.state.params.requestId = orderNo;
            this.state.params.orderNo = '';
        }
        this.state.params.begTime = this.state.starTime
        this.state.params.endTime = this.state.endTime
        this.state.params.userName = userName;
        $Axios('get', url, params, (res) => {
            let status = res.data.head.status;
            if (status == 200) {
                let data = res.data.body.list;
                let arr = [];
                data.map((item, index) => {
                    let obj = {
                        num: index + 1,
                        benbiPrice: item.benbiPrice,
                        cash: item.cash,
                        createTime: item.createTime == '' ? '--' : format(Number(item.createTime)), //:创建时间
                        finishTime: item.finishTime == '' ? '--' : format(Number(item.finishTime)),  //:完成时间
                        id: item.id,
                        orderNo: item.orderNo,
                        orderStatus: that_.orderStatus(item.payType),
                        payType: that_.payTypeList(item.payType),
                        refundAmount: item.refundAmount,
                        requestId: item.requestId,
                        stbPrice: item.stbPrice,
                        totalAmount: item.totalAmount,
                    };
                    arr.push(obj)
                })
                let total = res.data.body.totalCount;
                that_.state.paginationProps.total = total;
                that_.setState({
                    data: arr,
                    total: total,  //数据的总的条数
                    lodings: false
                })
            } else {
                message.info(res.data.body);
                that_.setState({
                    data: [],
                    total: 0,  //数据的总的条数
                    lodings: false
                })
            }

        })
    }

    xqClick(text, record, index) {
        this.setState({
            isModalVisible: true
        });
        this.initData_tk(record)
    }

    handleOk() {
        this.setState({
            isModalVisible: false
        })
    }

    initData_tk(e) {
        let that_ = this;
        that_.setState({
            tklodangs: false
        })
        let url = '/payment/merchant.order.query.groovy';
        let params = {
            action: "refundDetail",
            requestId: e.requestId,
        }
        $Axios('get', url, params, (res) => {
            let status = res.data.head.status;
            if (status == 200) {
                let refundInfo = res.data.body.refundInfo;
                let userInfo = res.data.body.userInfo;
                that_.setState({
                    refundInfo: refundInfo,
                    userInfo: userInfo,
                    tklodangs: true
                })
            }
        })
    }


    payTypeList(e) {
        let txt;
        if (e == 1) {
            txt = '支付宝'
        } else if (e == 2) {
            txt = '微信'
        } else if (e == 5) {
            txt = '余额'
        }
        return txt
    }

    orderStatus(e) {
        let txt;
        if (e == 2) {
            txt = '成功'
        } else if (e == 3) {
            txt = '失败'
        } else if (e == 1) {
            txt = '处理中'
        }
        return txt
    }


    handleChange_1(e) {  //退款状态
        this.state.params.orderStatus = e
    }

    handleChange_2(e) {  //支付方式
        this.state.params.payType = e
    }

    handleChange_3(e) {
        this.setState({
            types: e
        })
    }

    handleChange_4(e) {
    }

    handleChange_5(e) {
        this.state.params.timeType = e
        this.setState({
            timeType: e
        });
        if (e == 0) {
            this.setState({
                starTime: '',
                endTime: '',
                keys: new Date().getTime()
            });
        }
    }

    queryClick() {
        if (this.state.timeType !== 0 && this.state.timeType !== null) {
            if (this.state.endTime <= this.state.starTime && (this.state.starTime !== '' && this.state.endTime !== '')) {
                message.error('结束时间不可小于或者等于开始时间!');
            } else {
                if (this.state.starTime == '' && this.state.endTime == '') {
                    this.initData()
                } else if (this.state.starTime !== '' && this.state.endTime !== '') {
                    this.initData()
                } else {
                    if (this.state.starTime == '') {
                        message.error('请选择开始时间!');
                    } else if (this.state.endTime == '') {
                        message.error('请选择结束时间!');
                    }
                }
            }
        } else {
            this.initData()
        }

    }

    changePage(e) {
        this.state.params.pNo = e
        this.setState({
            current: e
        });
        this.initData();
    }


    starTime = (value, dateString) => {
        if (dateString !== '') {
            dateString = new Date(value).formats('yyyy-MM-dd 00:00:00')
            let time = new Date(dateString).getTime() / 1000;
            this.setState({
                starTime: time
            })
        } else {
            this.setState({
                starTime: ''
            })
        }

    }

    endTime = (value, dateString) => {
        if (dateString !== '') {
            dateString = new Date(value).formats('yyyy-MM-dd 00:00:00')
            let time = new Date(dateString).getTime() / 1000;
            this.setState({
                endTime: time
            })
        } else {
            this.setState({
                endTime: ''
            })
        }
    }



    render() {
        const { data, columns, headTxt, paginationProps, lodings, types, timeType, keys, isModalVisible, refundInfo, userInfo, tklodangs } = this.state;
        const { Option } = Select;
        return (
            <div className='wrap_table'>
                <div className='header_center'>
                    {headTxt}
                </div>
                <div className='query_table'>
                    <div className='top_div'>
                        <div style={{ display: 'inline-block', }}> 退款状态 ： </div>
                        <Select size='default' placeholder="请选择" onChange={this.handleChange_1.bind(this)} style={{ width: 200, marginRight: '20px' }}>
                            <Option key={1} value='2'>成功</Option>
                            <Option key={2} value='3'>失败</Option>
                            <Option key={3} value='1'>处理中</Option>
                        </Select>
                        <Select size='default' placeholder="订单号类型选择" onChange={this.handleChange_3.bind(this)} style={{ width: 200 }}>
                            <Option key={1} value={1}>商户订单号</Option>
                            <Option key={2} value={2}>退款请求号</Option>
                        </Select>
                        <div style={{ width: '200px', display: 'inline-block', marginLeft: '20px' }}><Input id='orderNo' disabled={types == null ? true : false} placeholder={types == 2 ? '请出入退款请求号' : '请输入商城订单号'} /></div>
                    </div>
                    <div className='btm_div'>
                        <div style={{ display: 'inline-block', }}> 发起人 ： </div>
                        <div style={{ width: '200px', display: 'inline-block', marginLeft: '20px', marginRight: '20px' }}><Input id='userName' placeholder="请输入用户名" /></div>
                        <div style={{ display: 'inline-block', }}> 支付方式 ： </div>
                        <Select size='default' placeholder="请选择" onChange={this.handleChange_2.bind(this)} style={{ width: 200, marginRight: '20px' }}>
                            <Option key={1} value={2}>微信</Option>
                            <Option key={2} value={1}>支付宝</Option>
                            <Option key={3} value={5}>钱包余额</Option>
                        </Select>
                        <Select size='default' placeholder="请选择时间类型" onChange={this.handleChange_5.bind(this)} style={{ width: 200, marginRight: '20px' }}>
                            <Option key={1} value={0}>不限时间类型</Option>
                            <Option key={1} value={1}>退款请求时间</Option>
                            <Option key={2} value={2}>退款完成时间</Option>
                        </Select>
                        <Space direction="vertical">
                            <DatePicker key={keys} onChange={this.starTime} locale={locale} disabled={timeType == null ? true : false || timeType == 0 ? true : false} placeholder='请选择开始时间' />
                        </Space>
                        <div style={{ display: 'inline-block', margin: '0px 10px', color: '#d9d9d9' }}>-</div>
                        <Space direction="vertical">
                            <DatePicker key={keys} onChange={this.endTime} locale={locale} disabled={timeType == null ? true : false || timeType == 0 ? true : false} placeholder='请选择结束时间' />
                        </Space>
                        <Button type="primary" style={{
                            float: 'right', display: 'inline-block', margin: '0px 10px', marginRight: '20px'
                        }}>导出</Button>
                        <Button type="primary" style={{
                            float: 'right', display: 'inline-block', margin: '0px 10px',
                        }} onClick={this.queryClick.bind(this)}>搜索</Button>
                    </div>
                </div>
                <div className='tables'>
                    <Table
                        columns={columns}
                        dataSource={data}
                        pagination={paginationProps}
                        loading={lodings}
                    />
                </div>
                <Modal title="退款详情"
                    wrapClassName={'webs'}
                    footer={[
                        <Button key="submit" type="primary" onClick={this.handleOk.bind(this)}>
                            确定
                        </Button>,
                    ]}
                    visible={isModalVisible}
                    closable={false}
                    mask={true}
                // onOk={this.handleOk} 
                >
                    {
                        tklodangs == false && <div style={{
                            width: '100%',
                            height: '300px',
                            textAlign : 'center',
                            fontSize : '20px',
                            color : '#ccc',
                            lineHeight : '300px'
                        }}>
                             <Spin tip="加载中请稍后..."></Spin>
                        </div>
                    }
                    {
                        tklodangs == true && <div>
                            <div>
                                <div style={{
                                    width: '50%',
                                    height: '300px',
                                    float: 'left',
                                }}>
                                    <p style={{ fontSize: '16px', fontWeight: '600' }}>付款人信息</p>
                                    <p>用户人 : {userInfo.nickname}</p>
                                    <p>电话 : {userInfo.mobile}</p>
                                    <p>邮箱 : {userInfo.email == '' ? '--' : userInfo.email}</p>
                                    <p>支付时间 : {userInfo.nickname}</p>
                                </div>
                                <div style={{
                                    width: '50%',
                                    height: '300px',
                                    float: 'left',
                                }}>
                                    <p style={{ fontSize: '16px', fontWeight: '600' }}>退款信息</p>
                                    <p>订单号 : {refundInfo.orderNo}</p>
                                    <p>订单金额 :  {refundInfo.totalAmount}</p>
                                    <p>退款金额 :  {refundInfo.cash}</p>
                                    <p>退款本币 :  {refundInfo.benbiPrice}</p>
                                    <p>退款积分币 :  {refundInfo.stbPrice}</p>
                                    <p>退款原因 :  {refundInfo.remark}</p>
                                    <p>退款账户 :  {refundInfo.orderNo}</p>
                                </div>
                            </div>
                            <div>
                                <p style={{ fontSize: '16px', fontWeight: '600' }}>退款进度</p>
                                <Steps size="small" current={refundInfo.orderStatus == 2 ? 3 : refundInfo.orderStatus} percent={50}>
                                    <Step title="商家同意退款" subTitle={format(Number(refundInfo.createTime))} description="系统会在1-2天内提交处理" />
                                    <Step title="已退款,处理中" description="系统处理中" />
                                    <Step title="处理成功" subTitle={format(Number(refundInfo.finishTime))} description="已交由微信/支付宝处理,请及时查看账户信息" />
                                </Steps>
                            </div>
                        </div>
                    }
                </Modal>
            </div>
        )
    }
}