import React from 'react';
import { Button, Table, Select, message, DatePicker, Space, Modal, Spin, Steps } from 'antd';
import 'moment/locale/zh-cn';
import locale from 'antd/es/date-picker/locale/zh_CN';
import { $Axios, format } from '../../common/publish';
import '../Withdrawal-record/Withdrawal-record.scss'
const { Column, ColumnGroup } = Table;
const { Step } = Steps;
export default class WithdrawalRecord extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            headTxt: '财务管理 > 提现记录',
            data: [],
            columns: [
                {
                    title: '序号',
                    dataIndex: 'num',
                    key: 'num',

                },
                {
                    title: '提现单号',
                    dataIndex: 'requestId',
                    key: 'requestId',
                },
                {
                    title: '提现金额',
                    dataIndex: 'withdrawAmount',
                    key: 'withdrawAmount',
                },
                {
                    title: '手续费',
                    dataIndex: 'fee',
                    key: 'fee',
                },
                {
                    title: '提现状态',
                    dataIndex: 'orderStatus',
                    key: 'orderStatus',
                },
                {
                    title: '提现时间',
                    dataIndex: 'createTime',
                    key: 'createTime',
                },
                {
                    title: '完成时间',
                    dataIndex: 'completeTime',
                    key: 'completeTime',
                },
                {
                    title: '操作',
                    dataIndex: 'cz',
                    key: 'cz',
                    render: (text, record, index) => <a onClick={() => this.xqClick(text, record, index)}>查看详情</a>,
                },
            ],
            keys: 1,
            keye: 2,
            timeType: null,
            current: 1,
            paginationProps: {
                showSizeChanger: false,//设置每页显示数据条数
                showQuickJumper: false,
                showTotal: () => `共${this.state.total}条`,
                pageSize: 10,
                total: null,  //数据的总的条数
                onChange: (current) => this.changePage(current), //点击当前页码
            },
            lodings: true,
            tradeStatus: '', //提现状态：1处理中PROCESS,2成功SUCCESS,3失败FAIL(inithecancle不统计)
            timeType: '',//为0或不提供此字段，表示不限制，1创建时间，2完成时间
            starTime: '',//"2021-06-3000:00:00",为空或不提供此字段，表示不限制
            endTime: '', //"2021-06-3000:00:00",为空或不提供此字段，表示不限制
            pNo: 1,
            isModalVisible: false,
            rowRecord : ''
        }

    }

    componentDidMount() {
        this.initData()
    }

    xqClick(text, record, index) {
        this.setState({
            isModalVisible: true,
            rowRecord : record
        })
    }

    handleOk_c(){
        this.setState({
            isModalVisible: false
        })
    }

    onChange(date, dateString) {
        // console.log(date, dateString);
    }

    changePage(e) {
        this.state.pNo = e
        this.setState({
            current: e
        });
        this.initData();
    }

    initData() {
        let that_ = this;
        that_.setState({
            lodings: true
        })
        let url = '/payment/merchant.order.query.groovy'
        let params = {
            action: "pickupList",//查询商户提现记录
            // appName : JSON.parse(localStorage.getItem('userData')).appName,testPickUpList
            appName: 'testPickUpList',
            tradeStatus: this.state.tradeStatus, //提现状态：1处理中PROCESS,2成功SUCCESS,3失败FAIL(inithecancle不统计)
            timeType: this.state.timeType,//为0或不提供此字段，表示不限制，1创建时间，2完成时间
            begTime: this.state.starTime,//"2021-06-3000:00:00",为空或不提供此字段，表示不限制
            endTime: this.state.endTime, //"2021-06-3000:00:00",为空或不提供此字段，表示不限制
            pSize: 10, //每页条数
            pNo: this.state.pNo//第几页，起始值从1开始
        }
        $Axios('get', url, params, (res) => {
            let status = res.data.head.status;
            if (status == 200) {
                let data = res.data.body.list;
                let arr = [];
                data.map((item, index) => {
                    let obj = {
                        num: index + 1,
                        bankCardNumber: item.bankCardNumber,
                        bankName: item.bankName,
                        completeTime: format(Number(item.completeTime)),
                        createTime: format(Number(item.createTime)),
                        fee: item.fee,
                        id: item.id,
                        orderStatus: that_.text(item.orderStatus),
                        requestId: item.requestId,
                        withdrawAmount: item.withdrawAmount,
                        orderStatusNums :　item.orderStatus == 2 ? 2 : 1
                    };
                    arr.push(obj)
                })
                let total = res.data.body.totalCount;
                that_.state.paginationProps.total = total
                that_.setState({
                    data: arr,
                    total: total,  //数据的总的条数
                    lodings: false
                })
            }
        })
    }

    text(e) {
        let txt;
        if (e == 1) {
            txt = '提现中'
        } else if (e == 2) {
            txt = '提现成功'
        } else if (e == 3) {
            txt = '提现失败'
        }
        return txt
    }

    starTime = (value, dateString) => {
        if (dateString !== '') {
            dateString = new Date(value).formats('yyyy-MM-dd 00:00:00')
            let time = new Date(dateString).getTime() / 1000;
            this.setState({
                starTime: time
            })
        } else {
            this.setState({
                starTime: ''
            })
        }

    }

    endTime = (value, dateString) => {
        if (dateString !== '') {
            dateString = new Date(value).formats('yyyy-MM-dd 00:00:00')
            let time = new Date(dateString).getTime() / 1000;
            this.setState({
                endTime: time
            })
        } else {
            this.setState({
                endTime: ''
            })
        }
    }


    handleChange_1(e) {
        this.setState({
            tradeStatus: e
        })
    }

    handleChange_2(e) {
        this.setState({
            timeType: e
        });
        if (e == 0) {
            this.setState({
                starTime: '',
                endTime: '',
                keys: new Date().getTime(),
                keye: new Date().getTime() * 1000,
            });
        }
    }

    queryClick() {
        if (this.state.timeType !== 0 && this.state.timeType !== null) {
            if (this.state.endTime <= this.state.starTime && (this.state.starTime !== '' && this.state.endTime !== '')) {
                message.error('结束时间不可小于或者等于开始时间!');
            } else {
                if (this.state.starTime == '' && this.state.endTime == '') {
                    this.initData()
                } else if (this.state.starTime !== '' && this.state.endTime !== '') {
                    this.initData()
                } else {
                    if (this.state.starTime == '') {
                        message.error('请选择开始时间!');
                    } else if (this.state.endTime == '') {
                        message.error('请选择结束时间!');
                    }
                }
            }
        } else {
            this.initData()
        }

    }

    render() {
        const { data, columns, headTxt, timeType, keys, keye, paginationProps, lodings, isModalVisible , rowRecord } = this.state;
        const { Option } = Select;
        return (
            <div className='wrap_table'>
                <div className='header_center'>
                    {headTxt}
                </div>
                <div className='query_table_l' style={{ height: '60px' }}>
                    <div className='btm_div' style={{ height: '100%', lineHeight: '60px', paddingLeft: '20px' }}>
                        <div style={{ display: 'inline-block', }}> 提现状态 ： </div>
                        <Select size='default' placeholder="请选择提现状态" onChange={this.handleChange_1.bind(this)} style={{ width: 200, marginRight: '20px' }}>
                            <Option key={1} value={1}>提现中</Option>
                            <Option key={2} value={2}>提现成功</Option>
                            <Option key={3} value={3}>提现失败</Option>
                        </Select>
                        <Select size='default' placeholder="请选择时间类型" onChange={this.handleChange_2.bind(this)} style={{ width: 200, marginRight: '20px' }}>
                            <Option key={0} value={0}>不限时间类型</Option>
                            <Option key={1} value={1}>创建时间</Option>
                            <Option key={2} value={2}>完成时间</Option>
                        </Select>
                        <Space direction="vertical">
                            <DatePicker key={keys} onChange={this.starTime} locale={locale} disabled={timeType == null ? true : false || timeType == 0 ? true : false} placeholder='请选择开始时间' />
                        </Space>
                        <div style={{ display: 'inline-block', margin: '0px 10px', color: '#d9d9d9' }}>-</div>
                        <Space direction="vertical">
                            <DatePicker key={keye} onChange={this.endTime} locale={locale} disabled={timeType == null ? true : false || timeType == 0 ? true : false} placeholder='请选择结束时间' />
                        </Space>
                        <Button type="primary" style={{
                            float: 'right', display: 'inline-block', margin: '15px 60px',
                        }} onClick={this.queryClick.bind(this)}>搜索</Button>
                    </div>
                </div>
                <div className='tables'>
                    <Table
                        columns={columns}
                        dataSource={data}
                        pagination={paginationProps}
                        loading={lodings}
                    />
                </div>
                <Modal title="提现详情"
                    // wrapClassName={'webs'}
                    footer={[
                        // <Button key="submit" type="primary" onClick={this.handleOk.bind(this)}>
                        //     确定
                        // </Button>,
                    ]}
                    visible={isModalVisible}
                    closable={true}
                    mask={true}
                onCancel={this.handleOk_c.bind(this)}
                >
                    <div>
                        <div>
                            <div>
                                <div style={{
                                    width: '100%',
                                }}>
                                    <p style={{ fontSize: '16px', fontWeight: '600' }}>提现信息</p>
                                    <p >提现金额 : <text style={{color : 'red' ,fontWeight : 600}}>{rowRecord.withdrawAmount}</text></p>
                                    <p>手续费 : {rowRecord.fee}</p>
                                    <p>到账账户 : {rowRecord.bankCardNumber}</p>
                                </div>
                            </div>
                            <div>
                                <p style={{ fontSize: '16px', fontWeight: '600' }}>提现进度</p>
                                <Steps size="small" current={rowRecord.orderStatusNums} percent={90}>
                                    <Step title="发起提现申请"description={rowRecord.createTime} />
                                    <Step title="提现成功" description={rowRecord.completeTime} />
                                </Steps>
                            </div>
                        </div>

                    </div>
                </Modal>
            </div>
        )
    }
}