import React from 'react';
import { Radio, Select, Input  } from 'antd';
// import { $Axios } from '../../common/publish';
import select_data from '../../common/ssq';
import '../center-o/centerO.scss'

export default class centerO extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            selectData : select_data,
            cityOs : true,
            regionOs : true, 
            citylist : [],
            regionlist : [],
            Params : this.props.arr,
            cityTxt : 1,
            regionTxt : 2,
            datas : null
        }
        
    }
	
    componentDidMount () {
        this.props.onRef(this)
        this.initData();
    }

    initData(){
        if(this.props.arr){  //初始化判断数据回填
            if(this.state.Params.businessAddressProvince !== undefined){
                let Province = this.state.Params.businessAddressProvince;
                let city = this.state.Params.businessAddressCity;
                let region = this.state.Params.businessAddressArea;
                let data = this.state.selectData.Area;
                let cityList = data.find((item,index) => { return Province == item.provinceCode});
                let regionlist = cityList.mallCityList.find((item,index) => { return city == item.cityCode});
                this.setState({
                    cityOs : false,
                    citylist : cityList.mallCityList,
                    regionOs : false,
                    regionlist: regionlist.mallAreaList
                })
            }
        }
    }

    toParent = (data) => {
        this.props.parent.getParams_o(this, data)
    }

    Inputdata(e){
        let Params = {
            signedType : 'BY_SPLIT_BILL',  //签约类型
            signedName :  document.getElementById("qymc").value, //签约名称
            signedShorthand : document.getElementById("names").value, //商户简称
            registerRole : this.state.Params.registerRole , //商户签约性质
            cerType : this.state.Params.cerType, //证书类型
            businessAddressProvince : this.state.Params.businessAddressProvince,//经营地省
            businessAddressCity : this.state.Params.businessAddressCity, //经营地市
            businessAddressArea : this.state.Params.businessAddressArea, //经营地区
            businessAddress : document.getElementById("mywb").value,  //经营详细地址
            contactName : document.getElementById("myname").value, //联系人姓名
            contactEmail : document.getElementById("mymail").value,// 联系人邮箱
            contactPhone : document.getElementById("mynums").value,// 联系人电话
            businessClassification : this.state.Params.businessClassification, //业务分类 (签约类型为被分账方不传此参数)
            desireAuth : this.state.Params.desireAuth, // 开户意愿核实类型
        }
        return Params
    }

    handleChangeQy(e) {  //商户签约性质
        let registerRole = e;
        this.state.Params.registerRole = registerRole;
        // console.log(this.state.Params)
    }

    handleChangeZs(e) {  //商户证书类型
        let cerType = e;
        this.state.Params.cerType = cerType;
        // console.log(this.state.Params)
    }

    province_select(e) {  //选择省
        this.state.Params.businessAddressProvince = e;
        let citylist = this.state.selectData.Area.find((item,index) => { return e == item.provinceCode});
        // console.log(e)
        // console.log(citylist)
        this.setState({
            cityOs : false,
            citylist :  citylist.mallCityList,
            cityTxt : e.value,
            regionTxt: e.value,
            regionOs : true,
        });
    }

    city_select(e) {  //选择市
        this.state.Params.businessAddressCity = e;
        let citylist = this.state.citylist;
        let regionlist;
        if(citylist.length == 1){
            regionlist = citylist[0].mallAreaList
        }else{
            regionlist = citylist.find((item,index) => { return e == item.cityCode}).mallAreaList
        }
        this.setState({
            regionOs : false,
            regionlist :  regionlist,
        })
    }

    region_select(e) {  //选择区
        this.state.Params.businessAddressArea = e;
    }

    Textarea(e){  //具体地址文本
        // console.log(e.target.value)
    }

    handleChange(e){ //业务类型
        // console.log(e)
        let businessClassification = e;
        this.state.Params.businessClassification = businessClassification;
    }

    onChangeRadio(e){ //开户意愿类型
        let desireAuth = e.target.value;
        this.state.Params.desireAuth = desireAuth;
        // console.log(this.state)
    }
    childMethod () { //暴露给父组件的方法,集合当前页面拿到的参数存入缓存
        let data = this.Inputdata();
        // console.log(data)
        // localStorage.setItem('data_o',JSON.stringify(data));
        this.toParent(data)
    }

    inputData(e){
        console.log(e)
    }


    render() {
        const {  selectData ,cityOs, regionOs ,citylist , regionlist ,cityTxt ,regionTxt , datas , Params } = this.state;
        const { Option } = Select;
        const { TextArea } = Input;
        return(
            <div className='center_up'>
                <div className='center_left'>
                    <div className='c-l'>
                        <div className='titles'> 商户入网类型<i className='label_x'>*</i> ： </div>
                        <Radio.Group name="radiogroup" defaultValue={1}>
                                            <Radio value={1}>被分帐方</Radio>
                                        </Radio.Group>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 签约名称<i className='label_x'>*</i>  ： </div>
                        <div className='inputs'><Input id='qymc' placeholder='请输入签约名称' defaultValue={Params.signedName}/></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 商户签约性质<i className='label_x'>*</i>  ： </div>
                        <Select 
                            size='default' 
                            id='qyxz' 
                            placeholder="请选择商户签约性质"  
                            defaultValue={Params.registerRole}
                            onChange={ this.handleChangeQy.bind(this) } 
                            style={{ width: 200 }}
                            >
                            {selectData.contract.map((item,index) => (
                                <Option key={index} value={item.value}>{item.txt}</Option>
                            ))}
                        </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 证书类型 ： </div>
                        <Select 
                            size='default' 
                            id='zslx' 
                            placeholder="请选择证书类型"  
                            defaultValue={Params.cerType}
                            onChange={ this.handleChangeZs.bind(this) } 
                            style={{ width: 200 }}
                            >
                            {selectData.certificate.map((item,index) => (
                                <Option key={index} value={item.value}>{item.txt}</Option>
                            ))}
                        </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 商户简称<i className='label_x'>*</i>  ： </div>
                        <div className='inputs'><Input id='names'  placeholder="请输入商户简称" defaultValue={Params.signedShorthand} /></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 联系人姓名<i className='label_x'>*</i>  ： </div>
                        <div className='inputs'><Input id='myname'   placeholder="请输入联系人姓名"  defaultValue={Params.contactName}/></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 联系人邮箱<i className='label_x'>*</i>  ： </div>
                        <div className='inputs'><Input id='mymail'  placeholder="请输入联系人邮箱"   defaultValue={Params.contactEmail} /></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 联系人电话<i className='label_x'>*</i>  ： </div> 
                        <div className='inputs'><Input  id='mynums'   placeholder="请输入联系人电话" onChange={ this.inputData.bind(this) }    defaultValue={Params.contactPhone}/></div>
                    </div>
                </div>
                <div className='center_right'>
                    <div className='c-l'>
                        <div className='titles_o'> 经营地址省<i className='label_x'>*</i>  ： </div>
                            <Select size='default'  placeholder="请选择省份" defaultValue={Params.businessAddressProvince} onChange={ this.province_select.bind(this) } style={{ width: 200 }}>
                                {selectData.Area.map((item,index) => (
                                    <Option key={index} value={item.provinceCode}>{item.provinceName}</Option>
                                ))}
                            </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles_o'> 经营地址市<i className='label_x'>*</i>  ： </div>
                            <Select size='default'  placeholder="请选择市" defaultValue={Params.businessAddressCity} key={cityTxt} onChange={ this.city_select.bind(this) } style={{ width: 200 }}  disabled={cityOs}>
                                {citylist.map((item,index) => (
                                    <Option key={index} value={item.cityCode}>{item.cityName}</Option>
                                ))}
                            </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles_o'> 经营地址区 ： </div>
                            <Select size='default'  placeholder="请选择区" defaultValue={Params.businessAddressArea} key={regionTxt} onChange={ this.region_select.bind(this) } style={{ width: 200 }}  disabled={regionOs}>
                                {regionlist.map((item,index) => (
                                    <Option key={index} value={item.areaCode}>{item.areaName}</Option>
                                ))}
                            </Select>
                    </div>
                    <div className='c-x'>
                        <div className='titles_txt'> 经营地址 ： </div>
                        <div className='TextAreas'>
                            <TextArea id='mywb' style={{resize:'none'}} defaultValue={Params.businessAddress} rows={6}/>
                        </div>
                    </div>
                    <div className='c-l'>
                        <div className='titles_o'> 业务类型 ： </div>
                            <Select size='default' placeholder="请选择业务类型" defaultValue={Params.businessClassification}  onChange={this.handleChange.bind(this)} style={{ width: 400 }}>
                                {selectData.fication.map((item,index) => (
                                    <Option key={index} value={item.value}>{item.txt}</Option>
                                ))}
                            </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles_o'> 开户意愿核实类型 ： </div>
                        <Radio.Group name="radiogroup" defaultValue={Params.desireAuth == undefined ? 'DESIRE_VIDEO' : Params.desireAuth} onChange={this.onChangeRadio.bind(this) }>
                                            <Radio value='DESIRE_VIDEO'>视频验证</Radio>
                                            <Radio value='DESIRE_MOBILEINFO'>手机短信验证</Radio>
                                            <Radio value='DESIRE_NONEED'>其他验证方式</Radio>
                                        </Radio.Group>
                    </div>
                    {/* <div className='c-l'>
                        <div className='titles_o'> 法人姓名 ： </div>
                        <div className='inputs'><Input id='myname'   placeholder="请输入法人姓名"  defaultValue={Params.contactName}/></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles_o'> 法人身份证号 ： </div>
                        <div className='inputs'><Input id='myname'   placeholder="请输入法人身份证号"  defaultValue={Params.contactName}/></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles_o'> 法人手机号 ： </div>
                        <div className='inputs'><Input id='myname'   placeholder="请输入法人手机号"  defaultValue={Params.contactName}/></div>
                    </div> */}
                </div>
            </div>
        )
    }
}