import React from 'react';
import { Radio, Select, Input  } from 'antd';
// import { $Axios } from '../../common/publish';
import select_data from '../../common/ssq';
import '../center-s/centerS.scss'

export default class centerS extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            selectData : select_data,
            Params : this.props.arr,
            cityOs : true,
            citylist : []
        }
        
    }
	
	componentDidMount() {
        this.props.onRef(this)
        this.initData()
    }

    toParent = (data) => {
        this.props.parent.getParams_s(this, data)
    }

    initData(){
        if(this.props.arr){  //初始化判断数据回填
            if(this.state.Params.provinceCode !== undefined){ // 判断回填数据内是否有省编码
                let Province = this.state.Params.provinceCode; //获取省编码
                let data = this.state.selectData.Area;  //拿到省数据组
                let cityList = data.find((item,index) => { return Province == item.provinceCode}); //抽取省编码内下的城市列表数据
                this.setState({  //重新设置数据
                    cityOs : false,
                    citylist : cityList.mallCityList,
                })
            }
        }
    }

    InputSdata(e){
        let Params = {
            bankCode : this.state.Params.bankCode,//开户行
            bankBranchName : document.getElementById("bankBranchName").value,//支行名称
            accountName : document.getElementById("accountName").value,//开户名称
            bankCardNo : document.getElementById("bankCardNo").value,//开户账号
            cityCode : this.state.Params.cityCode,//市编码
            provinceCode : this.state.Params.provinceCode,//省编码
            accountType : this.state.Params.accountType, //结算银行卡属性   PUBLIC 对公 PRIVATE 对私
            liquidationType : 'WITHDRAW',//清算方式 WITHDRAW 提现   SETTLE 结算
            withdrawRateType : this.state.Params.withdrawRateType,//提现费率类型
            withdrawRate : document.getElementById("withdrawRate").value,//提现费率
        }
        console.log(this.state.Params.withdrawRateType)
        return Params
    }

    childMethod () { //暴露给父组件的方法,集合当前页面拿到的参数存入缓存
        let data = this.InputSdata();
        console.log(data)
        this.toParent(data)
    }

    handleChange(value) {
        console.log(`Selected: ${value}`);
    }

    selectChange_1(value) {  //开户行选择
        this.state.Params.bankCode = value;
    }

    selectChange_2(value){ //省编码选择
        this.state.Params.provinceCode = value;
        let citylist = this.state.selectData.Area.find((item,index) => { return value == item.provinceCode});
        this.setState({
            cityOs : false,
            citylist :  citylist.mallCityList,
        });
    }
    
    selectChange_3(value){ //市编码选择
        this.state.Params.cityCode = value;
    }
    
    onChangeRadio(e){
        let accountType = e.target.value;
        this.state.Params.accountType = accountType;
    }

    onChangeRadio_s(e){
        console.log(e)
        let withdrawRateType = e;
        this.state.Params.withdrawRateType = withdrawRateType;
    }

    render() {
        const { selectData, cityOs , citylist ,Params} = this.state;
        const { Option } = Select;
        const { TextArea } = Input;
        return(
            <div className='center_up'>
                <div className='center_left'>
                    <div className='c-l'>
                        <div className='titles'> 开户行 ： </div>
                        <Select size='default' placeholder="请选择开户行" defaultValue={Params.bankCode}  onChange={ this.selectChange_1.bind(this) } style={{ width: 200 }}>
                                            {selectData.contractS.map((item,index) => (
                                                <Option key={index} value={item.value}>{item.txt}</Option>
                                            ))}
                                        </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 支行名称 ： </div>
                        <div className='inputs'><Input id='bankBranchName' defaultValue={Params.bankBranchName} placeholder="请输入支行名称" /></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 开户名称 ： </div>
                        <div className='inputs'><Input id='accountName' defaultValue={Params.accountName} placeholder="请输入开户名称" /></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 开户账号 ： </div>
                        <div className='inputs'><Input id='bankCardNo' defaultValue={Params.bankCardNo}  placeholder="请输入开户账号" /></div>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 省编码 ： </div>
                        <Select size='default' placeholder="请选择省编码" defaultValue={Params.provinceCode}  onChange={ this.selectChange_2.bind(this) } style={{ width: 200 }}>
                                            {console.log(selectData)}
                                            {selectData.Area.map((item,index) => (
                                                <Option key={index} value={item.provinceCode}>{item.provinceName}-{item.provinceCode}</Option>
                                            ))}
                                        </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 市编码 ： </div>
                        <Select size='default' placeholder="请选择市编码" defaultValue={Params.cityCode}  onChange={ this.selectChange_3.bind(this) } style={{ width: 200 }} disabled={cityOs}>
                                            {citylist.map((item,index) => (
                                                        <Option key={index} value={item.cityCode}>{item.cityName}-{item.cityCode}</Option>
                                                    ))}
                                        </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 结算银行卡属性 ： </div>
                        <Radio.Group name="radiogroup" defaultValue={Params.accountType == undefined ? 'PUBLIC' : Params.accountType} onChange={this.onChangeRadio.bind(this) }>
                                            <Radio value='PUBLIC'>对公</Radio>
                                            <Radio value='PRIVATE'>对私</Radio>
                                        </Radio.Group>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 清算方式 ： </div>
                        <Radio.Group name="radiogroup" defaultValue={1}>
                                            <Radio value={1}>提现</Radio>
                                        </Radio.Group>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 提现费率类型 ： </div>
                        <Select size='default' placeholder="请选择提现费率类型" defaultValue={Params.withdrawRateType == undefined ? 'SINGLE' : Params.withdrawRateType}   style={{ width: 200 }} onChange={this.onChangeRadio_s.bind(this) }>
                                            <Option key='SINGLE' value='SINGLE'>单笔</Option>
                                            <Option key='RATE' value='RATE'>百分比</Option>
                                        </Select>
                    </div>
                    <div className='c-l'>
                        <div className='titles'> 提现费率 ： </div>
                        <div className='inputs'><Input id='withdrawRate' defaultValue={Params.withdrawRate} placeholder="请输入提现费率" /></div>
                    </div>
                </div>
                <div className='center_right'> </div>
            </div>
        )
    }
}