import React from 'react';
import { Input, Upload, Button,message } from 'antd';
import axios from "axios";
import { UploadOutlined,LoadingOutlined, DownOutlined,UpOutlined  } from '@ant-design/icons';
export default class homePage extends React.Component {
    constructor(props) {
        super(props)
        this.state = {
            fileList : [],
            imgType : '',
            imageUrl : '',
            loading : '',
            url : '',
            select_o : false,
            select_t : false,
            RequestData : '',
            ResponseData : ''
        }
        
    }

	componentDidMount() {
        let box = document.getElementById("imgBox"); 
        if(box){ //此处在加一层判断，更加严密，如果box存在的情况下获取
            this.setState({
                height : box.offsetHeight + 'px'
            })
        }
    }

    getBase64(img, callback) { //解码图片信息及URL等
        const reader = new FileReader();
        reader.addEventListener('load', () => callback(reader.result));
        reader.readAsDataURL(img);
    }

    onChangeUpload(info){ //获取图片信息
        let taht_ = this;
        let fileList = [...info.fileList];
        this.state.fileList = fileList;
        if (info.file.status === 'uploading') { //图片上传状态改变
            this.setState({ loading: true });
        }
        this.getBase64(info.file.originFileObj, imageUrl => //图片上传状态改变 并获取URL储存
            taht_.setState({
                imageUrl,
                loading: false,
            }),
        );
    }

    btnClick(e){  //区分上传图片类型
        this.setState({	
            imgType : e
        })
    }

    btnClick_jc(){ //检测图片获取URL
        let url = document.getElementById("urls").value;
        this.setState({
            url : url
        });
        message.info(`已获取${url}`);
    }

    handleChange(e){
        let file = e.file;
        let that_ = this; //axios 内部指针不同 设置setState时候用that_
        const formData = new FormData();   //提交图片的格式
        formData.append('file', file)
        formData.append('merchantSerialNumber', 'MCT_202106262257460929210')  //可以自定义参数 例子
        let config = {
            method: 'post',  //请求方式
            headers: { 'Content-Type': 'multipart/form-data' } //请求头格式自定义
        }
        axios.post('http://xxxxxxxx',formData, config).then((res) => {
                // 上传成功后的回调
        }).catch((error) => { 
                //上传失败后回调
            console.log(error);
        })
        
    }

    select_o(){  //右侧第一个下拉菜单展开与收回
        let select_o = this.state.select_o;
        let data = 'RequestData数据组' //替换为API接口返回的数据 
        this.setState({
            select_o : select_o == false ? true : false,
            RequestData : data
        });
    }

    select_t(){ //右侧第二个下拉菜单展开与收回
        let select_t = this.state.select_t;
        let data = 'Response数据组' //替换为API接口返回的数据 
        this.setState({
            select_t : select_t == false ? true : false,
            ResponseData : data
        });
    }

    render() {
        const { loading,imageUrl,height,select_o,select_t,RequestData,ResponseData } = this.state;
        return(
            <div className='rootDom'>
               <div style={{
                   width : '80%',
                   height : '100%',
                   float : 'left',
                }}>
                    <div id='imgBox' style={{width:'100%',height:'90%',background:'rgba(0,0,0,0.5)'}}>
                        {
                            imageUrl == '' &&　<div className="icons-list" style={{width : '100%',height : '100%',background : 'rgba(0,0,0,0.5)',textAlign:'center',lineHeight:height,fontSize:'50px',color:'#ccc'}}>
                                您还没有上传图片~
                            </div>
                        }
                        {
                            loading == true &&　<div className="icons-list" style={{width : '100%',height : '100%',background : '#fff',textAlign:'center',lineHeight:height}}>
                            <LoadingOutlined style={{
                                fontSize :'50px',
                                color : 'rgb(24, 144, 255)',
                            }} />
                            </div>
                        }
                        {
                            imageUrl !== '' &&　<img alt="example" style={{ width: '100%',height:'100%' }} src={imageUrl} />
                        }
                    </div>
                    <div style={{width:'100%',height:'10%',background:'rgba(0,0,0,0.9)',padding : '2% 6%'}}>
                        <div style={{width : '50%',display:'inline-block'}}>
                            <Input id='urls' placeholder="请输入网络图片URL" />
                        </div>
                        <div style={{display:'inline-block'}}>
                            <Button type="primary" style={{width:'120px'}} onClick={() =>this.btnClick_jc()}>检测</Button>
                        </div>
                        <div style={{width : '10%',display:'inline-block',marginLeft:'30px',marginRight : '30px',textAlign:'center',fontSize:'20px',color:'#fff'}}>
                            或
                        </div>
                        <div style={{display:'inline-block'}}>
                            <Upload 
                                //  {...headerProps}
                                name="files"
                                className="Upload"
                                maxCount={1}   //限制图片上传个数
                                showUploadList={false}
                                accept = '.jpg, .jpeg, .png, .pdf'   //限制图片上传格式
                                customRequest={this.handleChange.bind(this)}  //自定义上传请求API
                                onChange={this.onChangeUpload.bind(this)}
                            >
                                <Button icon={<UploadOutlined />} type="primary" style={{width:'120px'}} onClick={() =>this.btnClick()}>本地上传</Button>
                            </Upload>
                        </div>
                       
                    </div>
                   
                </div>
                

               <div style={{
                   width : '20%',
                   height : '100%',
                   overflow:'auto',
                   float : 'left',
                }}>
                    <div 
                        style={{width:'100%',height : '60px',textAlign:'center',lineHeight:'60px',borderBottom:'1px solid #D3D3D3',backgroundColor: '#ccc',fontSize:'22px'}}
                        onClick={this.select_o.bind(this)}
                    >
                        Request 
                        {select_o == true && <DownOutlined style={{float:'right',marginRight : '20px' ,lineHeight:'60px'}} />}
                        {select_o == false &&<UpOutlined  style={{float:'right',marginRight : '20px' ,lineHeight:'60px'}} />}
                    </div>
                    {
                        select_o == true &&  <div style={{
                            width : '100%',
                            height : '500px',
                            backgroundColor: '#D3D3D3',
                            padding : '2%'
                        }}>
                            {RequestData}
                        </div>
                    }
                    <div 
                        style={{width:'100%',height : '60px',textAlign:'center',lineHeight:'60px',borderBottom:'1px solid #D3D3D3',backgroundColor: '#ccc',fontSize:'22px'}}
                        onClick={this.select_t.bind(this)}
                    >
                        Response 
                        {select_t == true && <DownOutlined style={{float:'right',marginRight : '20px' ,lineHeight:'60px'}} />}
                        {select_t == false &&<UpOutlined  style={{float:'right',marginRight : '20px' ,lineHeight:'60px'}} />}
                    </div>
                    {
                        select_t == true &&  <div style={{
                            width : '100%',
                            height : '500px',
                            backgroundColor: '#D3D3D3',
                            padding : '2%'
                        }}>
                            {ResponseData}
                        </div>
                    }
                </div>
            </div>
        )
    }
}